Update man page of gnt-cluster regarding file-storage-dir
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # Note: these are automake-specific variables, and must be named after
44 # the directory + 'dir' suffix
45 clientdir = $(pkgpythondir)/client
46 cmdlibdir = $(pkgpythondir)/cmdlib
47 hypervisordir = $(pkgpythondir)/hypervisor
48 storagedir = $(pkgpythondir)/storage
49 httpdir = $(pkgpythondir)/http
50 masterddir = $(pkgpythondir)/masterd
51 confddir = $(pkgpythondir)/confd
52 rapidir = $(pkgpythondir)/rapi
53 serverdir = $(pkgpythondir)/server
54 watcherdir = $(pkgpythondir)/watcher
55 impexpddir = $(pkgpythondir)/impexpd
56 utilsdir = $(pkgpythondir)/utils
57 toolsdir = $(pkglibdir)/tools
58 iallocatorsdir = $(pkglibdir)/iallocators
59 pytoolsdir = $(pkgpythondir)/tools
60 docdir = $(datadir)/doc/$(PACKAGE)
61 myexeclibdir = $(pkglibdir)
62
63 # Delete output file if an error occurred while building it
64 .DELETE_ON_ERROR:
65
66 HS_DIRS = \
67         src \
68         src/Ganeti \
69         src/Ganeti/Confd \
70         src/Ganeti/Curl \
71         src/Ganeti/DataCollectors \
72         src/Ganeti/HTools \
73         src/Ganeti/HTools/Backend \
74         src/Ganeti/HTools/Program \
75         src/Ganeti/Hypervisor \
76         src/Ganeti/Hypervisor/Xen \
77         src/Ganeti/Monitoring \
78         src/Ganeti/Query \
79         src/Ganeti/Storage \
80         src/Ganeti/Storage/Diskstats \
81         src/Ganeti/Storage/Drbd \
82         src/Ganeti/Storage/Lvm \
83         test/hs \
84         test/hs/Test \
85         test/hs/Test/Ganeti \
86         test/hs/Test/Ganeti/Storage \
87         test/hs/Test/Ganeti/Storage/Diskstats \
88         test/hs/Test/Ganeti/Storage/Drbd \
89         test/hs/Test/Ganeti/Storage/Lvm \
90         test/hs/Test/Ganeti/Confd \
91         test/hs/Test/Ganeti/HTools \
92         test/hs/Test/Ganeti/HTools/Backend \
93         test/hs/Test/Ganeti/Hypervisor \
94         test/hs/Test/Ganeti/Hypervisor/Xen \
95         test/hs/Test/Ganeti/Query
96
97 # Haskell directories without the roots (src, test/hs)
98 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
99
100 DIRS = \
101         $(HS_DIRS) \
102         autotools \
103         daemons \
104         devel \
105         devel/data \
106         doc \
107         doc/css \
108         doc/examples \
109         doc/examples/gnt-debug \
110         doc/examples/hooks \
111         test/data/htools \
112         test/data/htools/rapi \
113         test/hs/shelltests \
114         test/autotools \
115         lib \
116         lib/build \
117         lib/client \
118         lib/cmdlib \
119         lib/confd \
120         lib/http \
121         lib/hypervisor \
122         lib/impexpd \
123         lib/masterd \
124         lib/rapi \
125         lib/server \
126         lib/storage \
127         lib/tools \
128         lib/utils \
129         lib/watcher \
130         man \
131         qa \
132         test \
133         test/data \
134         test/data/bdev-rbd \
135         test/data/ovfdata \
136         test/data/ovfdata/other \
137         test/py \
138         tools
139
140 ALL_APIDOC_HS_DIRS = \
141         $(APIDOC_HS_DIR) \
142         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
143
144 BUILDTIME_DIR_AUTOCREATE = \
145         scripts \
146         $(APIDOC_DIR) \
147         $(ALL_APIDOC_HS_DIRS) \
148         $(APIDOC_PY_DIR) \
149         $(COVERAGE_DIR) \
150         $(COVERAGE_HS_DIR) \
151         $(COVERAGE_PY_DIR) \
152         .hpc
153
154 BUILDTIME_DIRS = \
155         $(BUILDTIME_DIR_AUTOCREATE) \
156         doc/html \
157         doc/man-html
158
159 DIRCHECK_EXCLUDE = \
160         $(BUILDTIME_DIRS) \
161         ganeti-[0-9]*.[0-9]*.[0-9]* \
162         doc/html/_* \
163         doc/man-html/_* \
164         autom4te.cache
165
166 # some helper vars
167 COVERAGE_DIR = doc/coverage
168 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
169 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
170 APIDOC_DIR = doc/api
171 APIDOC_PY_DIR = $(APIDOC_DIR)/py
172 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
173
174 MAINTAINERCLEANFILES = \
175         $(maninput) \
176         doc/install-quick.rst \
177         doc/news.rst \
178         doc/upgrade.rst \
179         vcs-version
180
181 maintainer-clean-local:
182         rm -rf $(BUILDTIME_DIRS)
183
184 CLEANFILES = \
185         $(addsuffix /*.py[co],$(DIRS)) \
186         $(addsuffix /*.hi,$(HS_DIRS)) \
187         $(addsuffix /*.o,$(HS_DIRS)) \
188         $(PYTHON_BOOTSTRAP) \
189         epydoc.conf \
190         $(REPLACE_VARS_SED) \
191         $(SHELL_ENV_INIT) \
192         daemons/daemon-util \
193         daemons/ganeti-cleaner \
194         devel/squeeze-amd64.tar.gz \
195         devel/squeeze-amd64.conf \
196         $(mandocrst) \
197         doc/manpages-enabled.rst \
198         $(BUILT_EXAMPLES) \
199         doc/examples/bash_completion \
200         doc/examples/bash_completion-debug \
201         lib/_generated_rpc.py \
202         $(man_MANS) \
203         $(manhtml) \
204         tools/kvm-ifup \
205         tools/vif-ganeti \
206         tools/net-common \
207         tools/users-setup \
208         tools/vcluster-setup \
209         stamp-directories \
210         stamp-srclinks \
211         $(nodist_pkgpython_PYTHON) \
212         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
213         $(HS_BUILT_TEST_HELPERS) \
214         src/ganeti-confd \
215         src/ganeti-luxid \
216         src/ganeti-mond \
217         .hpc/*.mix src/*.tix test/hs/*.tix \
218         doc/hs-lint.html
219
220 GENERATED_FILES = \
221         $(built_base_sources) \
222         $(BUILT_PYTHON_SOURCES) \
223         $(PYTHON_BOOTSTRAP)
224
225 HS_GENERATED_FILES =
226 if WANT_HTOOLS
227 HS_GENERATED_FILES += $(HS_PROGS)
228 if ENABLE_CONFD
229 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
230 endif
231
232 if ENABLE_MOND
233 HS_GENERATED_FILES += src/ganeti-mond
234 endif
235 endif
236
237 built_base_sources = \
238         stamp-directories \
239         stamp-srclinks
240
241 built_python_base_sources = \
242         lib/_autoconf.py \
243         lib/_vcsversion.py
244
245 BUILT_PYTHON_SOURCES = \
246         $(built_python_base_sources) \
247         lib/_generated_rpc.py
248
249 # Generating the RPC wrappers depends on many things, so make sure
250 # it's built at the end of the built sources
251 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
252
253 # these are all built from the underlying %.in sources
254 BUILT_EXAMPLES = \
255         doc/examples/ganeti-kvm-poweroff.initd \
256         doc/examples/ganeti.cron \
257         doc/examples/ganeti.initd \
258         doc/examples/ganeti-master-role.ocf \
259         doc/examples/ganeti-node-role.ocf \
260         doc/examples/gnt-config-backup \
261         doc/examples/hooks/ipsec
262
263 nodist_pkgpython_PYTHON = \
264         $(BUILT_PYTHON_SOURCES)
265
266 noinst_PYTHON = \
267         lib/build/__init__.py \
268         lib/build/shell_example_lexer.py \
269         lib/build/sphinx_ext.py
270
271 pkgpython_PYTHON = \
272         lib/__init__.py \
273         lib/asyncnotifier.py \
274         lib/backend.py \
275         lib/bootstrap.py \
276         lib/cli.py \
277         lib/compat.py \
278         lib/config.py \
279         lib/constants.py \
280         lib/daemon.py \
281         lib/errors.py \
282         lib/hooksmaster.py \
283         lib/ht.py \
284         lib/jqueue.py \
285         lib/jstore.py \
286         lib/locking.py \
287         lib/luxi.py \
288         lib/mcpu.py \
289         lib/netutils.py \
290         lib/objects.py \
291         lib/opcodes.py \
292         lib/outils.py \
293         lib/ovf.py \
294         lib/pathutils.py \
295         lib/qlang.py \
296         lib/query.py \
297         lib/rpc.py \
298         lib/rpc_defs.py \
299         lib/runtime.py \
300         lib/serializer.py \
301         lib/ssconf.py \
302         lib/ssh.py \
303         lib/uidpool.py \
304         lib/vcluster.py \
305         lib/network.py \
306         lib/workerpool.py
307
308 client_PYTHON = \
309         lib/client/__init__.py \
310         lib/client/gnt_backup.py \
311         lib/client/gnt_cluster.py \
312         lib/client/gnt_debug.py \
313         lib/client/gnt_group.py \
314         lib/client/gnt_instance.py \
315         lib/client/gnt_job.py \
316         lib/client/gnt_node.py \
317         lib/client/gnt_network.py \
318         lib/client/gnt_os.py \
319         lib/client/gnt_storage.py
320
321 cmdlib_PYTHON = \
322         lib/cmdlib/__init__.py \
323         lib/cmdlib/backup.py \
324         lib/cmdlib/base.py \
325         lib/cmdlib/cluster.py \
326         lib/cmdlib/common.py \
327         lib/cmdlib/group.py \
328         lib/cmdlib/instance.py \
329         lib/cmdlib/instance_migration.py \
330         lib/cmdlib/instance_operation.py \
331         lib/cmdlib/instance_query.py \
332         lib/cmdlib/instance_storage.py \
333         lib/cmdlib/instance_utils.py \
334         lib/cmdlib/misc.py \
335         lib/cmdlib/network.py \
336         lib/cmdlib/node.py \
337         lib/cmdlib/operating_system.py \
338         lib/cmdlib/query.py \
339         lib/cmdlib/tags.py \
340         lib/cmdlib/test.py
341
342 hypervisor_PYTHON = \
343         lib/hypervisor/__init__.py \
344         lib/hypervisor/hv_base.py \
345         lib/hypervisor/hv_chroot.py \
346         lib/hypervisor/hv_fake.py \
347         lib/hypervisor/hv_kvm.py \
348         lib/hypervisor/hv_lxc.py \
349         lib/hypervisor/hv_xen.py
350
351 storage_PYTHON = \
352         lib/storage/__init__.py \
353         lib/storage/bdev.py \
354         lib/storage/base.py \
355         lib/storage/container.py \
356         lib/storage/drbd.py \
357         lib/storage/drbd_info.py \
358         lib/storage/drbd_cmdgen.py \
359         lib/storage/filestorage.py
360
361 rapi_PYTHON = \
362         lib/rapi/__init__.py \
363         lib/rapi/baserlib.py \
364         lib/rapi/client.py \
365         lib/rapi/client_utils.py \
366         lib/rapi/connector.py \
367         lib/rapi/rlib2.py \
368         lib/rapi/testutils.py
369
370 http_PYTHON = \
371         lib/http/__init__.py \
372         lib/http/auth.py \
373         lib/http/client.py \
374         lib/http/server.py
375
376 confd_PYTHON = \
377         lib/confd/__init__.py \
378         lib/confd/client.py
379
380 masterd_PYTHON = \
381         lib/masterd/__init__.py \
382         lib/masterd/iallocator.py \
383         lib/masterd/instance.py
384
385 impexpd_PYTHON = \
386         lib/impexpd/__init__.py
387
388 watcher_PYTHON = \
389         lib/watcher/__init__.py \
390         lib/watcher/nodemaint.py \
391         lib/watcher/state.py
392
393 server_PYTHON = \
394         lib/server/__init__.py \
395         lib/server/masterd.py \
396         lib/server/noded.py \
397         lib/server/rapi.py
398
399 pytools_PYTHON = \
400         lib/tools/__init__.py \
401         lib/tools/burnin.py \
402         lib/tools/ensure_dirs.py \
403         lib/tools/node_cleanup.py \
404         lib/tools/node_daemon_setup.py \
405         lib/tools/prepare_node_join.py
406
407 utils_PYTHON = \
408         lib/utils/__init__.py \
409         lib/utils/algo.py \
410         lib/utils/filelock.py \
411         lib/utils/hash.py \
412         lib/utils/io.py \
413         lib/utils/log.py \
414         lib/utils/lvm.py \
415         lib/utils/mlock.py \
416         lib/utils/nodesetup.py \
417         lib/utils/process.py \
418         lib/utils/retry.py \
419         lib/utils/storage.py \
420         lib/utils/text.py \
421         lib/utils/wrapper.py \
422         lib/utils/x509.py
423
424 docinput = \
425         doc/conf.py \
426         doc/css/style.css \
427         doc/admin.rst \
428         doc/cluster-merge.rst \
429         doc/design-2.0.rst \
430         doc/design-2.1.rst \
431         doc/design-2.2.rst \
432         doc/design-2.3.rst \
433         doc/design-2.4.rst \
434         doc/design-2.5.rst \
435         doc/design-2.6.rst \
436         doc/design-2.7.rst \
437         doc/design-2.8.rst \
438         doc/design-autorepair.rst \
439         doc/design-bulk-create.rst \
440         doc/design-chained-jobs.rst \
441         doc/design-cpu-pinning.rst \
442         doc/design-device-uuid-name.rst \
443         doc/design-draft.rst \
444         doc/design-htools-2.3.rst \
445         doc/design-http-server.rst \
446         doc/design-impexp2.rst \
447         doc/design-internal-shutdown.rst \
448         doc/design-lu-generated-jobs.rst \
449         doc/design-linuxha.rst \
450         doc/design-multi-reloc.rst \
451         doc/design-network.rst \
452         doc/design-node-add.rst \
453         doc/design-oob.rst \
454         doc/design-ovf-support.rst \
455         doc/design-opportunistic-locking.rst \
456         doc/design-partitioned.rst \
457         doc/design-query-splitting.rst \
458         doc/design-query2.rst \
459         doc/design-reason-trail.rst \
460         doc/design-resource-model.rst \
461         doc/design-restricted-commands.rst \
462         doc/design-shared-storage.rst \
463         doc/design-monitoring-agent.rst \
464         doc/design-virtual-clusters.rst \
465         doc/design-x509-ca.rst \
466         doc/design-hroller.rst \
467         doc/design-storagetypes.rst \
468         doc/devnotes.rst \
469         doc/glossary.rst \
470         doc/hooks.rst \
471         doc/iallocator.rst \
472         doc/index.rst \
473         doc/install-quick.rst \
474         doc/install.rst \
475         doc/locking.rst \
476         doc/manpages-disabled.rst \
477         doc/move-instance.rst \
478         doc/news.rst \
479         doc/ovfconverter.rst \
480         doc/rapi.rst \
481         doc/security.rst \
482         doc/upgrade.rst \
483         doc/virtual-cluster.rst \
484         doc/walkthrough.rst
485
486 # Generates file names such as "doc/man-gnt-instance.rst"
487 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
488
489 # Haskell programs to be installed in $PREFIX/bin
490 HS_BIN_PROGS=src/htools
491
492 # Haskell programs to be installed in the MYEXECLIB dir
493 if ENABLE_MOND
494 HS_MYEXECLIB_PROGS=src/mon-collector
495 else
496 HS_MYEXECLIB_PROGS=
497 endif
498
499 # Haskell programs to be compiled by "make really-all"
500 HS_COMPILE_PROGS= \
501         src/ganeti-mond \
502         src/hconfd \
503         src/hluxid \
504         src/rpc-test
505
506 # All Haskell non-test programs to be compiled but not automatically installed
507 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
508
509 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
510 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
511
512 HS_ALL_PROGS = \
513         $(HS_PROGS) \
514         test/hs/hpc-htools \
515         test/hs/hpc-mon-collector \
516         test/hs/htest \
517         $(HS_COMPILE_PROGS)
518
519 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
520 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
521
522 HFLAGS = \
523         -O -Wall -Werror -isrc \
524         -fwarn-monomorphism-restriction \
525         -fwarn-tabs \
526         $(GHC_BYVERSION_FLAGS)
527
528 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
529 HEXTRA =
530 # internal extra flags (used for test/hs/htest mainly)
531 HEXTRA_INT =
532 # exclude options for coverage reports
533 HPCEXCL = --exclude Main \
534         --exclude Ganeti.Constants \
535         --exclude Ganeti.HTools.QC \
536         --exclude Ganeti.THH \
537         --exclude Ganeti.Version \
538         --exclude Test.Ganeti.Attoparsec \
539         --exclude Test.Ganeti.TestCommon \
540         --exclude Test.Ganeti.TestHTools \
541         --exclude Test.Ganeti.TestHelper \
542         --exclude Test.Ganeti.TestImports \
543         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
544
545 HS_LIB_SRCS = \
546         src/Ganeti/BasicTypes.hs \
547         src/Ganeti/Common.hs \
548         src/Ganeti/Compat.hs \
549         src/Ganeti/Confd/Client.hs \
550         src/Ganeti/Confd/ClientFunctions.hs \
551         src/Ganeti/Confd/Server.hs \
552         src/Ganeti/Confd/Types.hs \
553         src/Ganeti/Confd/Utils.hs \
554         src/Ganeti/Config.hs \
555         src/Ganeti/ConfigReader.hs \
556         src/Ganeti/Curl/Multi.hs \
557         src/Ganeti/Daemon.hs \
558         src/Ganeti/DataCollectors/CLI.hs \
559         src/Ganeti/DataCollectors/Diskstats.hs \
560         src/Ganeti/DataCollectors/Drbd.hs \
561         src/Ganeti/DataCollectors/InstStatus.hs \
562         src/Ganeti/DataCollectors/InstStatusTypes.hs \
563         src/Ganeti/DataCollectors/Lv.hs \
564         src/Ganeti/DataCollectors/Program.hs \
565         src/Ganeti/DataCollectors/Types.hs \
566         src/Ganeti/Errors.hs \
567         src/Ganeti/HTools/Backend/IAlloc.hs \
568         src/Ganeti/HTools/Backend/Luxi.hs \
569         src/Ganeti/HTools/Backend/Rapi.hs \
570         src/Ganeti/HTools/Backend/Simu.hs \
571         src/Ganeti/HTools/Backend/Text.hs \
572         src/Ganeti/HTools/CLI.hs \
573         src/Ganeti/HTools/Cluster.hs \
574         src/Ganeti/HTools/Container.hs \
575         src/Ganeti/HTools/ExtLoader.hs \
576         src/Ganeti/HTools/Graph.hs \
577         src/Ganeti/HTools/Group.hs \
578         src/Ganeti/HTools/Instance.hs \
579         src/Ganeti/HTools/Loader.hs \
580         src/Ganeti/HTools/Nic.hs \
581         src/Ganeti/HTools/Node.hs \
582         src/Ganeti/HTools/PeerMap.hs \
583         src/Ganeti/HTools/Program/Hail.hs \
584         src/Ganeti/HTools/Program/Harep.hs \
585         src/Ganeti/HTools/Program/Hbal.hs \
586         src/Ganeti/HTools/Program/Hcheck.hs \
587         src/Ganeti/HTools/Program/Hinfo.hs \
588         src/Ganeti/HTools/Program/Hscan.hs \
589         src/Ganeti/HTools/Program/Hspace.hs \
590         src/Ganeti/HTools/Program/Hroller.hs \
591         src/Ganeti/HTools/Program/Main.hs \
592         src/Ganeti/HTools/Types.hs \
593         src/Ganeti/Hypervisor/Xen.hs \
594         src/Ganeti/Hypervisor/Xen/XmParser.hs \
595         src/Ganeti/Hypervisor/Xen/Types.hs \
596         src/Ganeti/Hash.hs \
597         src/Ganeti/JQueue.hs \
598         src/Ganeti/JSON.hs \
599         src/Ganeti/Jobs.hs \
600         src/Ganeti/Logging.hs \
601         src/Ganeti/Luxi.hs \
602         src/Ganeti/Monitoring/Server.hs \
603         src/Ganeti/Network.hs \
604         src/Ganeti/Objects.hs \
605         src/Ganeti/OpCodes.hs \
606         src/Ganeti/OpParams.hs \
607         src/Ganeti/Path.hs \
608         src/Ganeti/Query/Cluster.hs \
609         src/Ganeti/Query/Common.hs \
610         src/Ganeti/Query/Export.hs \
611         src/Ganeti/Query/Filter.hs \
612         src/Ganeti/Query/Group.hs \
613         src/Ganeti/Query/Job.hs \
614         src/Ganeti/Query/Language.hs \
615         src/Ganeti/Query/Network.hs \
616         src/Ganeti/Query/Node.hs \
617         src/Ganeti/Query/Query.hs \
618         src/Ganeti/Query/Server.hs \
619         src/Ganeti/Query/Types.hs \
620         src/Ganeti/Rpc.hs \
621         src/Ganeti/Runtime.hs \
622         src/Ganeti/Ssconf.hs \
623         src/Ganeti/Storage/Diskstats/Parser.hs \
624         src/Ganeti/Storage/Diskstats/Types.hs \
625         src/Ganeti/Storage/Drbd/Parser.hs \
626         src/Ganeti/Storage/Drbd/Types.hs \
627         src/Ganeti/Storage/Lvm/LVParser.hs \
628         src/Ganeti/Storage/Lvm/Types.hs \
629         src/Ganeti/Storage/Utils.hs \
630         src/Ganeti/THH.hs \
631         src/Ganeti/Types.hs \
632         src/Ganeti/Utils.hs
633
634 HS_TEST_SRCS = \
635         test/hs/Test/Ganeti/Attoparsec.hs \
636         test/hs/Test/Ganeti/BasicTypes.hs \
637         test/hs/Test/Ganeti/Common.hs \
638         test/hs/Test/Ganeti/Confd/Types.hs \
639         test/hs/Test/Ganeti/Confd/Utils.hs \
640         test/hs/Test/Ganeti/Daemon.hs \
641         test/hs/Test/Ganeti/Errors.hs \
642         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
643         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
644         test/hs/Test/Ganeti/HTools/CLI.hs \
645         test/hs/Test/Ganeti/HTools/Cluster.hs \
646         test/hs/Test/Ganeti/HTools/Container.hs \
647         test/hs/Test/Ganeti/HTools/Graph.hs \
648         test/hs/Test/Ganeti/HTools/Instance.hs \
649         test/hs/Test/Ganeti/HTools/Loader.hs \
650         test/hs/Test/Ganeti/HTools/Node.hs \
651         test/hs/Test/Ganeti/HTools/PeerMap.hs \
652         test/hs/Test/Ganeti/HTools/Types.hs \
653         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
654         test/hs/Test/Ganeti/JSON.hs \
655         test/hs/Test/Ganeti/Jobs.hs \
656         test/hs/Test/Ganeti/JQueue.hs \
657         test/hs/Test/Ganeti/Luxi.hs \
658         test/hs/Test/Ganeti/Network.hs \
659         test/hs/Test/Ganeti/Objects.hs \
660         test/hs/Test/Ganeti/OpCodes.hs \
661         test/hs/Test/Ganeti/Query/Filter.hs \
662         test/hs/Test/Ganeti/Query/Language.hs \
663         test/hs/Test/Ganeti/Query/Network.hs \
664         test/hs/Test/Ganeti/Query/Query.hs \
665         test/hs/Test/Ganeti/Rpc.hs \
666         test/hs/Test/Ganeti/Runtime.hs \
667         test/hs/Test/Ganeti/Ssconf.hs \
668         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
669         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
670         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
671         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
672         test/hs/Test/Ganeti/THH.hs \
673         test/hs/Test/Ganeti/TestCommon.hs \
674         test/hs/Test/Ganeti/TestHTools.hs \
675         test/hs/Test/Ganeti/TestHelper.hs \
676         test/hs/Test/Ganeti/Types.hs \
677         test/hs/Test/Ganeti/Utils.hs
678
679 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
680
681 HS_BUILT_SRCS = \
682         test/hs/Test/Ganeti/TestImports.hs \
683         src/Ganeti/Constants.hs \
684         src/Ganeti/Curl/Internal.hs \
685         src/Ganeti/Version.hs
686 HS_BUILT_SRCS_IN = \
687         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
688         src/Ganeti/Curl/Internal.hsc
689
690 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
691
692 $(RUN_IN_TEMPDIR): | stamp-directories
693
694 doc/html/index.html: ENABLE_MANPAGES =
695 doc/man-html/index.html: ENABLE_MANPAGES = 1
696 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
697
698 # Note: we use here an order-only prerequisite, as the contents of
699 # _autoconf.py are not actually influencing the html build output: it
700 # has to exist in order for the sphinx module to be loaded
701 # successfully, but we certainly don't want the docs to be rebuilt if
702 # it changes
703 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
704         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
705         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
706         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
707         | $(BUILT_PYTHON_SOURCES)
708         @test -n "$(SPHINX)" || \
709             { echo 'sphinx-build' not found during configure; exit 1; }
710 if !MANPAGES_IN_DOC
711         if test -n '$(ENABLE_MANPAGES)'; then \
712           echo 'Man pages in documentation were disabled at configure time' >&2; \
713           exit 1; \
714         fi
715 endif
716 ## Sphinx provides little control over what content should be included. Some
717 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
718 ## build two different versions of the documentation--once without man pages and
719 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
720 ## us with this, but requires running in a temporary directory. It moves the
721 ## correct files into place depending on environment variables.
722         dir=$(dir $@) && \
723         @mkdir_p@ $$dir && \
724         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
725         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
726             -d . \
727             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
728             -D release="$(PACKAGE_VERSION)" \
729             -D graphviz_dot="$(DOT)" \
730             -D enable_manpages="$(ENABLE_MANPAGES)" \
731             doc $(CURDIR)/$$dir && \
732         rm -f $$dir/.buildinfo $$dir/objects.inv
733         touch $@
734
735 doc/html: doc/html/index.html
736
737 doc/man-html: doc/man-html/index.html
738
739 doc/install-quick.rst: INSTALL
740 doc/news.rst: NEWS
741 doc/upgrade.rst: UPGRADE
742
743 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
744         set -e; \
745         { echo '.. This file is automatically updated at build time from $<.'; \
746           echo '.. Do not edit.'; \
747           echo; \
748           cat $<; \
749         } > $@
750
751 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
752         { echo '.. This file is automatically generated, do not edit!'; \
753           echo ''; \
754           echo 'Man pages'; \
755           echo '========='; \
756           echo; \
757           echo '.. toctree::'; \
758           echo '   :maxdepth: 1'; \
759           echo; \
760           for i in $(notdir $(mandocrst)); do \
761             echo "   $$i"; \
762           done | LC_ALL=C sort; \
763         } > $@
764
765 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
766 if MANPAGES_IN_DOC
767         { echo '.. This file is automatically updated at build time from $<.'; \
768           echo '.. Do not edit.'; \
769           echo; \
770           echo "$*"; \
771           echo '=========================================='; \
772           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
773         } > $@
774 else
775         echo 'Man pages in documentation were disabled at configure time' >&2; \
776         exit 1;
777 endif
778
779 # Things to build but not to install (add it to EXTRA_DIST if it should be
780 # distributed)
781 noinst_DATA = \
782         doc/html \
783         $(BUILT_EXAMPLES) \
784         doc/examples/bash_completion \
785         doc/examples/bash_completion-debug \
786         $(manhtml)
787
788 if MANPAGES_IN_DOC
789 noinst_DATA += doc/man-html
790 endif
791
792 gnt_scripts = \
793         scripts/gnt-backup \
794         scripts/gnt-cluster \
795         scripts/gnt-debug \
796         scripts/gnt-group \
797         scripts/gnt-instance \
798         scripts/gnt-job \
799         scripts/gnt-network \
800         scripts/gnt-node \
801         scripts/gnt-os \
802         scripts/gnt-storage
803
804 PYTHON_BOOTSTRAP_SBIN = \
805         daemons/ganeti-masterd \
806         daemons/ganeti-noded \
807         daemons/ganeti-rapi \
808         daemons/ganeti-watcher \
809         $(gnt_scripts)
810
811 PYTHON_BOOTSTRAP = \
812         $(PYTHON_BOOTSTRAP_SBIN) \
813         tools/burnin \
814         tools/ensure-dirs \
815         tools/node-cleanup \
816         tools/node-daemon-setup \
817         tools/prepare-node-join
818
819 qa_scripts = \
820         qa/__init__.py \
821         qa/ganeti-qa.py \
822         qa/qa_cluster.py \
823         qa/qa_config.py \
824         qa/qa_daemon.py \
825         qa/qa_env.py \
826         qa/qa_error.py \
827         qa/qa_group.py \
828         qa/qa_instance.py \
829         qa/qa_instance_utils.py \
830         qa/qa_job.py \
831         qa/qa_monitoring.py \
832         qa/qa_node.py \
833         qa/qa_os.py \
834         qa/qa_rapi.py \
835         qa/qa_tags.py \
836         qa/qa_utils.py
837
838 bin_SCRIPTS =
839 if WANT_HTOOLS
840 bin_SCRIPTS += $(HS_BIN_PROGS)
841 install-exec-hook:
842         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
843 # FIXME: this is a hardcoded logic, instead of auto-resolving
844         $(LN_S) -f ../../../bin/htools \
845           $(DESTDIR)$(iallocatorsdir)/hail
846         for role in $(HS_BIN_ROLES); do \
847           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
848         done
849 endif
850
851 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
852         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
853           echo "Error: cannot run unittests without the development" \
854                " libraries (see devnotes.rst)" 1>&2; \
855           exit 1; \
856         fi
857         @rm -f $(notdir $@).tix
858         $(GHC) --make \
859           $(HFLAGS) \
860           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
861           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
862           $(HEXTRA) $(HEXTRA_INT) $@
863         @touch "$@"
864
865 # for the test/hs/htest binary, we need to enable profiling/coverage
866 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
867
868 # we compile the hpc-htools binary with the program coverage
869 test/hs/hpc-htools: HEXTRA_INT=-fhpc
870
871 # we compile the hpc-mon-collector binary with the program coverage
872 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
873
874 # test dependency
875 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
876
877 # rules for building profiling-enabled versions of the haskell
878 # programs: hs-prof does the full two-step build, whereas
879 # hs-prof-quick does only the final rebuild (hs-prof must have been
880 # run before)
881 .PHONY: hs-prof hs-prof-quick
882 hs-prof:
883         @if [ -z "$(TARGET)" ]; then \
884           echo "You need to define TARGET when running this rule" 1>&2; \
885           exit 1; \
886         fi
887         $(MAKE) $(AM_MAKEFLAGS) clean
888         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
889         rm -f $(HS_ALL_PROGS)
890         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
891
892 hs-prof-quick:
893         @if [ -z "$(TARGET)" ]; then \
894           echo "You need to define TARGET when running this rule" 1>&2; \
895           exit 1; \
896         fi
897         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
898
899 dist_sbin_SCRIPTS = \
900         tools/ganeti-listrunner
901
902 nodist_sbin_SCRIPTS = \
903         $(PYTHON_BOOTSTRAP_SBIN) \
904         daemons/ganeti-cleaner
905
906 if ENABLE_CONFD
907 src/ganeti-confd: src/hconfd
908         cp -f $< $@
909
910 src/ganeti-luxid: src/hluxid
911         cp -f $< $@
912
913 nodist_sbin_SCRIPTS += src/ganeti-confd
914 nodist_sbin_SCRIPTS += src/ganeti-luxid
915 endif
916
917 if ENABLE_MOND
918 nodist_sbin_SCRIPTS += src/ganeti-mond
919 endif
920
921 python_scripts = \
922         tools/cfgshell \
923         tools/cfgupgrade \
924         tools/cfgupgrade12 \
925         tools/cluster-merge \
926         tools/confd-client \
927         tools/fmtjson \
928         tools/lvmstrap \
929         tools/move-instance \
930         tools/ovfconverter \
931         tools/sanitize-config
932
933 dist_tools_SCRIPTS = \
934         $(python_scripts) \
935         tools/burnin \
936         tools/kvm-console-wrapper \
937         tools/master-ip-setup \
938         tools/xen-console-wrapper
939
940 nodist_tools_python_scripts = \
941         tools/node-cleanup
942
943 nodist_tools_SCRIPTS = \
944         $(nodist_tools_python_scripts) \
945         tools/users-setup \
946         tools/vcluster-setup
947
948 pkglib_python_scripts = \
949         daemons/import-export \
950         tools/check-cert-expired
951
952 nodist_pkglib_python_scripts = \
953         tools/ensure-dirs \
954         tools/node-daemon-setup \
955         tools/prepare-node-join
956
957 myexeclib_SCRIPTS = \
958         daemons/daemon-util \
959         tools/kvm-ifup \
960         tools/vif-ganeti \
961         tools/net-common \
962         $(pkglib_python_scripts) \
963         $(HS_MYEXECLIB_PROGS)
964
965 nodist_myexeclib_SCRIPTS = \
966         $(nodist_pkglib_python_scripts)
967
968 EXTRA_DIST = \
969         NEWS \
970         UPGRADE \
971         epydoc.conf.in \
972         pylintrc \
973         autotools/build-bash-completion \
974         autotools/build-rpc \
975         autotools/check-header \
976         autotools/check-imports \
977         autotools/check-man-dashes \
978         autotools/check-man-references \
979         autotools/check-man-warnings \
980         autotools/check-news \
981         autotools/check-python-code \
982         autotools/check-tar \
983         autotools/check-version \
984         autotools/convert-constants \
985         autotools/docpp \
986         autotools/gen-py-coverage \
987         autotools/sphinx-wrapper \
988         autotools/testrunner \
989         autotools/wrong-hardcoded-paths \
990         $(RUN_IN_TEMPDIR) \
991         daemons/daemon-util.in \
992         daemons/ganeti-cleaner.in \
993         $(pkglib_python_scripts) \
994         devel/upload \
995         devel/webserver \
996         tools/kvm-ifup.in \
997         tools/vif-ganeti.in \
998         tools/net-common.in \
999         tools/users-setup.in \
1000         tools/vcluster-setup.in \
1001         $(docinput) \
1002         doc/html \
1003         $(BUILT_EXAMPLES:%=%.in) \
1004         doc/examples/ganeti.default \
1005         doc/examples/ganeti.default-debug \
1006         doc/examples/hooks/ethers \
1007         doc/examples/gnt-debug/README \
1008         doc/examples/gnt-debug/delay0.json \
1009         doc/examples/gnt-debug/delay50.json \
1010         test/py/lockperf.py \
1011         test/py/testutils.py \
1012         test/py/mocks.py \
1013         $(dist_TESTS) \
1014         $(TEST_FILES) \
1015         man/footer.rst \
1016         $(manrst) \
1017         $(maninput) \
1018         qa/qa-sample.json \
1019         $(qa_scripts) \
1020         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1021         $(HS_PROG_SRCS) \
1022         src/lint-hints.hs \
1023         test/hs/cli-tests-defs.sh \
1024         test/hs/offline-test.sh \
1025         .ghci
1026
1027 man_MANS = \
1028         man/ganeti-cleaner.8 \
1029         man/ganeti-confd.8 \
1030         man/ganeti-luxid.8 \
1031         man/ganeti-listrunner.8 \
1032         man/ganeti-masterd.8 \
1033         man/ganeti-mond.8 \
1034         man/ganeti-noded.8 \
1035         man/ganeti-os-interface.7 \
1036         man/ganeti-extstorage-interface.7 \
1037         man/ganeti-rapi.8 \
1038         man/ganeti-watcher.8 \
1039         man/ganeti.7 \
1040         man/gnt-backup.8 \
1041         man/gnt-cluster.8 \
1042         man/gnt-debug.8 \
1043         man/gnt-group.8 \
1044         man/gnt-network.8 \
1045         man/gnt-instance.8 \
1046         man/gnt-job.8 \
1047         man/gnt-node.8 \
1048         man/gnt-os.8 \
1049         man/gnt-storage.8 \
1050         man/hail.1 \
1051         man/harep.1 \
1052         man/hbal.1 \
1053         man/hcheck.1 \
1054         man/hinfo.1 \
1055         man/hscan.1 \
1056         man/hspace.1 \
1057         man/hroller.1 \
1058         man/htools.1 \
1059         man/mon-collector.7
1060
1061 # Remove extensions from all filenames in man_MANS
1062 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1063
1064 manrst = $(patsubst %,%.rst,$(mannoext))
1065 manhtml = $(patsubst %.rst,%.html,$(manrst))
1066 mangen = $(patsubst %.rst,%.gen,$(manrst))
1067 maninput = \
1068         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1069         $(patsubst %.html,%.html.in,$(manhtml)) \
1070         $(mangen)
1071
1072 TEST_FILES = \
1073         test/autotools/autotools-check-news.test \
1074         test/data/htools/clean-nonzero-score.data \
1075         test/data/htools/common-suffix.data \
1076         test/data/htools/empty-cluster.data \
1077         test/data/htools/hail-alloc-drbd.json \
1078         test/data/htools/hail-alloc-invalid-network.json \
1079         test/data/htools/hail-alloc-invalid-twodisks.json \
1080         test/data/htools/hail-alloc-restricted-network.json \
1081         test/data/htools/hail-alloc-spindles.json \
1082         test/data/htools/hail-alloc-twodisks.json \
1083         test/data/htools/hail-change-group.json \
1084         test/data/htools/hail-invalid-reloc.json \
1085         test/data/htools/hail-node-evac.json \
1086         test/data/htools/hail-reloc-drbd.json \
1087         test/data/htools/hbal-excl-tags.data \
1088         test/data/htools/hbal-split-insts.data \
1089         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1090         test/data/htools/hspace-tiered-dualspec.data \
1091         test/data/htools/hspace-tiered-exclusive.data \
1092         test/data/htools/hspace-tiered-ipolicy.data \
1093         test/data/htools/hspace-tiered-mixed.data \
1094         test/data/htools/hspace-tiered-resourcetypes.data \
1095         test/data/htools/hspace-tiered-vcpu.data \
1096         test/data/htools/hspace-tiered.data \
1097         test/data/htools/invalid-node.data \
1098         test/data/htools/missing-resources.data \
1099         test/data/htools/multiple-master.data \
1100         test/data/htools/multiple-tags.data \
1101         test/data/htools/n1-failure.data \
1102         test/data/htools/rapi/groups.json \
1103         test/data/htools/rapi/info.json \
1104         test/data/htools/rapi/instances.json \
1105         test/data/htools/rapi/nodes.json \
1106         test/data/htools/hroller-full.data \
1107         test/data/htools/hroller-nodegroups.data \
1108         test/data/htools/hroller-nonredundant.data \
1109         test/data/htools/hroller-online.data \
1110         test/data/htools/unique-reboot-order.data \
1111         test/hs/shelltests/htools-balancing.test \
1112         test/hs/shelltests/htools-basic.test \
1113         test/hs/shelltests/htools-dynutil.test \
1114         test/hs/shelltests/htools-excl.test \
1115         test/hs/shelltests/htools-hail.test \
1116         test/hs/shelltests/htools-hroller.test \
1117         test/hs/shelltests/htools-hspace.test \
1118         test/hs/shelltests/htools-invalid.test \
1119         test/hs/shelltests/htools-multi-group.test \
1120         test/hs/shelltests/htools-no-backend.test \
1121         test/hs/shelltests/htools-rapi.test \
1122         test/hs/shelltests/htools-single-group.test \
1123         test/hs/shelltests/htools-text-backend.test \
1124         test/hs/shelltests/htools-mon-collector.test \
1125         test/data/bdev-drbd-8.0.txt \
1126         test/data/bdev-drbd-8.3.txt \
1127         test/data/bdev-drbd-8.4.txt \
1128         test/data/bdev-drbd-8.4-no-disk-params.txt \
1129         test/data/bdev-drbd-disk.txt \
1130         test/data/bdev-drbd-net-ip4.txt \
1131         test/data/bdev-drbd-net-ip6.txt \
1132         test/data/bdev-rbd/json_output_empty.txt \
1133         test/data/bdev-rbd/json_output_extra_matches.txt \
1134         test/data/bdev-rbd/json_output_no_matches.txt \
1135         test/data/bdev-rbd/json_output_ok.txt \
1136         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1137         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1138         test/data/bdev-rbd/plain_output_new_ok.txt \
1139         test/data/bdev-rbd/plain_output_old_empty.txt \
1140         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1141         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1142         test/data/bdev-rbd/plain_output_old_ok.txt \
1143         test/data/bdev-rbd/output_invalid.txt \
1144         test/data/cert1.pem \
1145         test/data/cert2.pem \
1146         test/data/cluster_config_2.7.json \
1147         test/data/cluster_config_2.8.json \
1148         test/data/instance-minor-pairing.txt \
1149         test/data/instance-prim-sec.txt \
1150         test/data/ip-addr-show-dummy0.txt \
1151         test/data/ip-addr-show-lo-ipv4.txt \
1152         test/data/ip-addr-show-lo-ipv6.txt \
1153         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1154         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1155         test/data/ip-addr-show-lo-oneline.txt \
1156         test/data/ip-addr-show-lo.txt \
1157         test/data/kvm_0.12.5_help.txt \
1158         test/data/kvm_0.15.90_help.txt \
1159         test/data/kvm_0.9.1_help.txt \
1160         test/data/kvm_0.9.1_help_boot_test.txt \
1161         test/data/kvm_1.0_help.txt \
1162         test/data/kvm_1.1.2_help.txt \
1163         test/data/lvs_lv.txt \
1164         test/data/NEWS_OK.txt \
1165         test/data/NEWS_previous_unreleased.txt \
1166         test/data/ovfdata/compr_disk.vmdk.gz \
1167         test/data/ovfdata/config.ini \
1168         test/data/ovfdata/corrupted_resources.ovf \
1169         test/data/ovfdata/empty.ini \
1170         test/data/ovfdata/empty.ovf \
1171         test/data/ovfdata/ganeti.mf \
1172         test/data/ovfdata/ganeti.ovf \
1173         test/data/ovfdata/gzip_disk.ovf \
1174         test/data/ovfdata/new_disk.vmdk \
1175         test/data/ovfdata/no_disk.ini \
1176         test/data/ovfdata/no_disk_in_ref.ovf \
1177         test/data/ovfdata/no_os.ini \
1178         test/data/ovfdata/no_ovf.ova \
1179         test/data/ovfdata/other/rawdisk.raw \
1180         test/data/ovfdata/ova.ova \
1181         test/data/ovfdata/rawdisk.raw \
1182         test/data/ovfdata/second_disk.vmdk \
1183         test/data/ovfdata/unsafe_path.ini \
1184         test/data/ovfdata/virtualbox.ovf \
1185         test/data/ovfdata/wrong_config.ini \
1186         test/data/ovfdata/wrong_extension.ovd \
1187         test/data/ovfdata/wrong_manifest.mf \
1188         test/data/ovfdata/wrong_manifest.ovf \
1189         test/data/ovfdata/wrong_ova.ova \
1190         test/data/ovfdata/wrong_xml.ovf \
1191         test/data/proc_diskstats.txt \
1192         test/data/proc_drbd8.txt \
1193         test/data/proc_drbd80-emptyline.txt \
1194         test/data/proc_drbd80-emptyversion.txt \
1195         test/data/proc_drbd83.txt \
1196         test/data/proc_drbd83_sync.txt \
1197         test/data/proc_drbd83_sync_want.txt \
1198         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1199         test/data/proc_drbd84.txt \
1200         test/data/proc_drbd84_sync.txt \
1201         test/data/qa-minimal-nodes-instances-only.json \
1202         test/data/sys_drbd_usermode_helper.txt \
1203         test/data/vgreduce-removemissing-2.02.02.txt \
1204         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1205         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1206         test/data/vgs-missing-pvs-2.02.02.txt \
1207         test/data/vgs-missing-pvs-2.02.66.txt \
1208         test/data/xen-xm-info-4.0.1.txt \
1209         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1210         test/data/xen-xm-list-4.0.1-four-instances.txt \
1211         test/data/xen-xm-list-long-4.0.1.txt \
1212         test/data/xen-xm-uptime-4.0.1.txt \
1213         test/py/ganeti-cli.test \
1214         test/py/gnt-cli.test \
1215         test/py/import-export_unittest-helper
1216
1217
1218 python_tests = \
1219         doc/examples/rapi_testutils.py \
1220         test/py/cfgupgrade_unittest.py \
1221         test/py/docs_unittest.py \
1222         test/py/ganeti.asyncnotifier_unittest.py \
1223         test/py/ganeti.backend_unittest-runasroot.py \
1224         test/py/ganeti.backend_unittest.py \
1225         test/py/ganeti.bootstrap_unittest.py \
1226         test/py/ganeti.cli_unittest.py \
1227         test/py/ganeti.client.gnt_cluster_unittest.py \
1228         test/py/ganeti.client.gnt_instance_unittest.py \
1229         test/py/ganeti.client.gnt_job_unittest.py \
1230         test/py/ganeti.cmdlib_unittest.py \
1231         test/py/ganeti.cmdlib.cluster_unittest.py \
1232         test/py/ganeti.cmdlib.instance_storage_unittest.py \
1233         test/py/ganeti.compat_unittest.py \
1234         test/py/ganeti.confd.client_unittest.py \
1235         test/py/ganeti.config_unittest.py \
1236         test/py/ganeti.constants_unittest.py \
1237         test/py/ganeti.daemon_unittest.py \
1238         test/py/ganeti.errors_unittest.py \
1239         test/py/ganeti.hooks_unittest.py \
1240         test/py/ganeti.ht_unittest.py \
1241         test/py/ganeti.http_unittest.py \
1242         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1243         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1244         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1245         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1246         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1247         test/py/ganeti.hypervisor_unittest.py \
1248         test/py/ganeti.impexpd_unittest.py \
1249         test/py/ganeti.jqueue_unittest.py \
1250         test/py/ganeti.jstore_unittest.py \
1251         test/py/ganeti.locking_unittest.py \
1252         test/py/ganeti.luxi_unittest.py \
1253         test/py/ganeti.masterd.iallocator_unittest.py \
1254         test/py/ganeti.masterd.instance_unittest.py \
1255         test/py/ganeti.mcpu_unittest.py \
1256         test/py/ganeti.netutils_unittest.py \
1257         test/py/ganeti.objects_unittest.py \
1258         test/py/ganeti.opcodes_unittest.py \
1259         test/py/ganeti.outils_unittest.py \
1260         test/py/ganeti.ovf_unittest.py \
1261         test/py/ganeti.qlang_unittest.py \
1262         test/py/ganeti.query_unittest.py \
1263         test/py/ganeti.rapi.baserlib_unittest.py \
1264         test/py/ganeti.rapi.client_unittest.py \
1265         test/py/ganeti.rapi.resources_unittest.py \
1266         test/py/ganeti.rapi.rlib2_unittest.py \
1267         test/py/ganeti.rapi.testutils_unittest.py \
1268         test/py/ganeti.rpc_unittest.py \
1269         test/py/ganeti.runtime_unittest.py \
1270         test/py/ganeti.serializer_unittest.py \
1271         test/py/ganeti.server.rapi_unittest.py \
1272         test/py/ganeti.ssconf_unittest.py \
1273         test/py/ganeti.ssh_unittest.py \
1274         test/py/ganeti.storage.bdev_unittest.py \
1275         test/py/ganeti.storage.container_unittest.py \
1276         test/py/ganeti.storage.drbd_unittest.py \
1277         test/py/ganeti.storage.filestorage_unittest.py \
1278         test/py/ganeti.tools.burnin_unittest.py \
1279         test/py/ganeti.tools.ensure_dirs_unittest.py \
1280         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1281         test/py/ganeti.tools.prepare_node_join_unittest.py \
1282         test/py/ganeti.uidpool_unittest.py \
1283         test/py/ganeti.utils.algo_unittest.py \
1284         test/py/ganeti.utils.filelock_unittest.py \
1285         test/py/ganeti.utils.hash_unittest.py \
1286         test/py/ganeti.utils.io_unittest-runasroot.py \
1287         test/py/ganeti.utils.io_unittest.py \
1288         test/py/ganeti.utils.log_unittest.py \
1289         test/py/ganeti.utils.lvm_unittest.py \
1290         test/py/ganeti.utils.mlock_unittest.py \
1291         test/py/ganeti.utils.nodesetup_unittest.py \
1292         test/py/ganeti.utils.process_unittest.py \
1293         test/py/ganeti.utils.retry_unittest.py \
1294         test/py/ganeti.utils.storage_unittest.py \
1295         test/py/ganeti.utils.text_unittest.py \
1296         test/py/ganeti.utils.wrapper_unittest.py \
1297         test/py/ganeti.utils.x509_unittest.py \
1298         test/py/ganeti.utils_unittest.py \
1299         test/py/ganeti.vcluster_unittest.py \
1300         test/py/ganeti.workerpool_unittest.py \
1301         test/py/pycurl_reset_unittest.py \
1302         test/py/qa.qa_config_unittest.py \
1303         test/py/tempfile_fork_unittest.py
1304
1305 haskell_tests = test/hs/htest
1306
1307 dist_TESTS = \
1308         test/py/check-cert-expired_unittest.bash \
1309         test/py/daemon-util_unittest.bash \
1310         test/py/ganeti-cleaner_unittest.bash \
1311         test/py/import-export_unittest.bash \
1312         test/py/cli-test.bash \
1313         test/py/bash_completion.bash
1314
1315 if PY_UNIT
1316 dist_TESTS += $(python_tests)
1317 endif
1318
1319 nodist_TESTS =
1320 check_SCRIPTS =
1321
1322 if WANT_HSTESTS
1323 nodist_TESTS += $(haskell_tests)
1324 dist_TESTS += test/hs/offline-test.sh
1325 check_SCRIPTS += \
1326         test/hs/hpc-htools \
1327         test/hs/hpc-mon-collector \
1328         $(HS_BUILT_TEST_HELPERS)
1329 endif
1330
1331 TESTS = $(dist_TESTS) $(nodist_TESTS)
1332
1333 # Environment for all tests
1334 PLAIN_TESTS_ENVIRONMENT = \
1335         PYTHONPATH=. \
1336         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1337         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1338         $(RUN_IN_TEMPDIR)
1339
1340 # Environment for tests run by automake
1341 TESTS_ENVIRONMENT = \
1342         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1343
1344 all_python_code = \
1345         $(dist_sbin_SCRIPTS) \
1346         $(python_scripts) \
1347         $(pkglib_python_scripts) \
1348         $(nodist_pkglib_python_scripts) \
1349         $(nodist_tools_python_scripts) \
1350         $(pkgpython_PYTHON) \
1351         $(client_PYTHON) \
1352         $(cmdlib_PYTHON) \
1353         $(hypervisor_PYTHON) \
1354         $(storage_PYTHON) \
1355         $(rapi_PYTHON) \
1356         $(server_PYTHON) \
1357         $(pytools_PYTHON) \
1358         $(http_PYTHON) \
1359         $(confd_PYTHON) \
1360         $(masterd_PYTHON) \
1361         $(impexpd_PYTHON) \
1362         $(utils_PYTHON) \
1363         $(watcher_PYTHON) \
1364         $(noinst_PYTHON) \
1365         $(qa_scripts)
1366
1367 if PY_UNIT
1368 all_python_code += $(python_tests)
1369 endif
1370
1371 srclink_files = \
1372         man/footer.rst \
1373         test/py/check-cert-expired_unittest.bash \
1374         test/py/daemon-util_unittest.bash \
1375         test/py/ganeti-cleaner_unittest.bash \
1376         test/py/import-export_unittest.bash \
1377         test/py/cli-test.bash \
1378         test/py/bash_completion.bash \
1379         test/hs/offline-test.sh \
1380         test/hs/cli-tests-defs.sh \
1381         $(all_python_code) \
1382         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1383         $(docinput)
1384
1385 check_python_code = \
1386         $(BUILD_BASH_COMPLETION) \
1387         $(CHECK_IMPORTS) \
1388         $(CHECK_HEADER) \
1389         $(DOCPP) \
1390         $(all_python_code)
1391
1392 lint_python_code = \
1393         ganeti \
1394         ganeti/http/server.py \
1395         $(dist_sbin_SCRIPTS) \
1396         $(python_scripts) \
1397         $(pkglib_python_scripts) \
1398         $(BUILD_BASH_COMPLETION) \
1399         $(CHECK_IMPORTS) \
1400         $(CHECK_HEADER) \
1401         $(DOCPP) \
1402         $(PYTHON_BOOTSTRAP)
1403
1404 standalone_python_modules = \
1405         lib/rapi/client.py \
1406         tools/ganeti-listrunner
1407
1408 pep8_python_code = \
1409         ganeti \
1410         ganeti/http/server.py \
1411         $(dist_sbin_SCRIPTS) \
1412         $(python_scripts) \
1413         $(pkglib_python_scripts) \
1414         $(BUILD_BASH_COMPLETION) \
1415         $(CHECK_HEADER) \
1416         $(DOCPP) \
1417         $(PYTHON_BOOTSTRAP) \
1418         qa
1419
1420 test/py/daemon-util_unittest.bash: daemons/daemon-util
1421
1422 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1423
1424 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1425
1426 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1427         sed -f $(REPLACE_VARS_SED) < $< > $@
1428         chmod +x $@
1429
1430 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1431         sed -f $(REPLACE_VARS_SED) < $< > $@
1432         chmod +x $@
1433
1434 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1435         sed -f $(REPLACE_VARS_SED) < $< > $@
1436         chmod +x $@
1437
1438 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1439         sed -f $(REPLACE_VARS_SED) < $< > $@
1440         chmod +x $@
1441
1442 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1443         sed -f $(REPLACE_VARS_SED) < $< > $@
1444         chmod +x $@
1445
1446 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1447         sed -f $(REPLACE_VARS_SED) < $< > $@
1448         chmod +x $@
1449
1450 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1451         sed -f $(REPLACE_VARS_SED) < $< > $@
1452
1453 doc/examples/bash_completion: BC_ARGS = --compact
1454 doc/examples/bash_completion-debug: BC_ARGS =
1455
1456 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1457         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1458         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1459         daemons/ganeti-cleaner \
1460         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1461         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1462           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1463
1464 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1465         lib/build/shell_example_lexer.py \
1466         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1467         @echo "Checking $< for hardcoded paths..."
1468         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1469           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1470           exit 1; \
1471         fi
1472         set -e ; \
1473         trap 'echo auto-removing $@; rm $@' EXIT; \
1474         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1475         $(CHECK_MAN_REFERENCES) $@; \
1476         trap - EXIT
1477
1478 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1479         @test -n "$(PANDOC)" || \
1480           { echo 'pandoc' not found during configure; exit 1; }
1481         set -o pipefail -e; \
1482         trap 'echo auto-removing $@; rm $@' EXIT; \
1483         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1484           sed -e 's/\\@/@/g' > $@; \
1485         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1486         $(CHECK_MAN_DASHES) $@; \
1487         trap - EXIT
1488
1489 man/%.html.in: man/%.gen man/footer.rst
1490         @test -n "$(PANDOC)" || \
1491           { echo 'pandoc' not found during configure; exit 1; }
1492         set -o pipefail ; \
1493         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1494           sed -e 's/\\@/@/g' > $@
1495
1496 man/%: man/%.in  $(REPLACE_VARS_SED)
1497         sed -f $(REPLACE_VARS_SED) < $< > $@
1498
1499 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1500         sed -f $(REPLACE_VARS_SED) < $< > $@
1501
1502 vcs-version:
1503         if test -d .git; then \
1504           git describe > $@; \
1505         elif test ! -f $@ ; then \
1506           echo "Cannot auto-generate $@ file"; exit 1; \
1507         fi
1508
1509 .PHONY: clean-vcs-version
1510 clean-vcs-version:
1511         rm -f vcs-version
1512
1513 .PHONY: regen-vcs-version
1514 regen-vcs-version:
1515         @set -e; \
1516         cd $(srcdir); \
1517         if test -d .git; then \
1518           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1519           git describe > $$T; \
1520           if ! cmp --quiet $$T vcs-version; then \
1521             mv $$T vcs-version; \
1522           fi; \
1523         fi
1524
1525 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1526         vcs-version $(built_base_sources)
1527         set -e; \
1528         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1529         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1530
1531 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1532         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1533         lib/jstore.py $(RUN_IN_TEMPDIR) \
1534         $(CONVERT_CONSTANTS) $(built_base_sources) \
1535         | lib/_vcsversion.py
1536         set -e; \
1537         { cat $< ; \
1538           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1539         } > $@
1540
1541 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1542         hsc2hs -o $@ $<
1543
1544 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1545         $(built_base_sources)
1546         set -e; \
1547         { cat $< ; \
1548           echo ; \
1549           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1550             echo "import $$name ()" ; \
1551           done ; \
1552         } > $@
1553
1554 lib/_autoconf.py: Makefile | stamp-directories
1555         set -e; \
1556         { echo '# This file is automatically generated, do not edit!'; \
1557           echo '#'; \
1558           echo ''; \
1559           echo '"""Build-time configuration for Ganeti.'; \
1560           echo '';\
1561           echo 'This file is autogenerated by the build process.'; \
1562           echo 'For any changes you need to re-run ./configure (and'; \
1563           echo 'not edit by hand).'; \
1564           echo ''; \
1565           echo '"""'; \
1566           echo ''; \
1567           echo '# pylint: disable=C0301,C0324'; \
1568           echo '# because this is autogenerated, we do not want'; \
1569           echo '# style warnings' ; \
1570           echo ''; \
1571           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1572           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1573           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1574           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1575           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1576           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1577           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1578           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1579           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1580           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1581           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1582           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1583           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1584           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1585           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1586           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1587           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1588           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1589           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1590           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1591           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1592           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1593           echo "KVM_PATH = '$(KVM_PATH)'"; \
1594           echo "IP_PATH = '$(IP_PATH)'"; \
1595           echo "SOCAT_PATH = '$(SOCAT)'"; \
1596           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1597           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1598           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1599           echo "TOOLSDIR = '$(toolsdir)'"; \
1600           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1601           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1602           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1603           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1604           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1605           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1606           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1607           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1608           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1609           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1610           echo "RAPI_USER = '$(RAPI_USER)'"; \
1611           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1612           echo "CONFD_USER = '$(CONFD_USER)'"; \
1613           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1614           echo "LUXID_USER = '$(LUXID_USER)'"; \
1615           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1616           echo "NODED_USER = '$(NODED_USER)'"; \
1617           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1618           echo "MOND_USER = '$(MOND_USER)'"; \
1619           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1620           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1621           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1622           echo "HTOOLS = True"; \
1623           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1624           echo "XEN_CMD = '$(XEN_CMD)'"; \
1625           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1626           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1627           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1628 ## Write dictionary with man page name as the key and the section number as the
1629 ## value
1630           echo "MAN_PAGES = {"; \
1631           for i in $(notdir $(man_MANS)); do \
1632             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1633           done; \
1634           echo "}"; \
1635         } > $@
1636
1637 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1638         set -e; \
1639         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1640         { echo '# This file is automatically generated, do not edit!'; \
1641           echo '#'; \
1642           echo ''; \
1643           echo '"""Build-time VCS version number for Ganeti.'; \
1644           echo '';\
1645           echo 'This file is autogenerated by the build process.'; \
1646           echo 'For any changes you need to re-run ./configure (and'; \
1647           echo 'not edit by hand).'; \
1648           echo ''; \
1649           echo '"""'; \
1650           echo ''; \
1651           echo '# pylint: disable=C0301,C0324'; \
1652           echo '# because this is autogenerated, we do not want'; \
1653           echo '# style warnings' ; \
1654           echo ''; \
1655           echo "VCS_VERSION = '$$VCSVER'"; \
1656         } > $@
1657
1658 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1659         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1660
1661 $(SHELL_ENV_INIT): Makefile stamp-directories
1662         set -e; \
1663         { echo '# Allow overriding for tests'; \
1664           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1665           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1666           echo; \
1667           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1668           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1669           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1670           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1671           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1672         } > $@
1673
1674 ## Writes sed script to replace placeholders with build-time values. The
1675 ## additional quotes after the first @ sign are necessary to stop configure
1676 ## from replacing those values as well.
1677 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1678         set -e; \
1679         { echo 's#@''PREFIX@#$(prefix)#g'; \
1680           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1681           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1682           echo 's#@''BINDIR@#$(bindir)#g'; \
1683           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1684           echo 's#@''LIBDIR@#$(libdir)#g'; \
1685           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1686           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1687           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1688           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1689           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1690           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1691           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1692           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1693           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1694           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1695           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1696           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1697           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1698           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1699           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1700           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1701           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1702           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1703           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1704           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1705           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1706           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1707           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1708           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1709           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1710           echo; \
1711           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1712           echo '  r $(SHELL_ENV_INIT)'; \
1713           echo '  d'; \
1714           echo '}'; \
1715         } > $@
1716
1717 # Using deferred evaluation
1718 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1719 daemons/ganeti-watcher: MODULE = ganeti.watcher
1720 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1721 tools/burnin: MODULE = ganeti.tools.burnin
1722 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1723 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1724 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1725 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1726 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1727
1728 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1729         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1730         set -e; \
1731         { echo '#!/usr/bin/python'; \
1732           echo '# This file is automatically generated, do not edit!'; \
1733           echo "# Edit $(MODULE) instead."; \
1734           echo; \
1735           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1736           echo; \
1737           echo '# pylint: disable=C0103'; \
1738           echo '# C0103: Invalid name'; \
1739           echo; \
1740           echo 'import sys'; \
1741           echo 'import $(MODULE) as main'; \
1742           echo; \
1743           echo '# Temporarily alias commands until bash completion'; \
1744           echo '# generator is changed'; \
1745           echo 'if hasattr(main, "commands"):'; \
1746           echo '  commands = main.commands # pylint: disable=E1101'; \
1747           echo 'if hasattr(main, "aliases"):'; \
1748           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1749           echo; \
1750           echo 'if __name__ == "__main__":'; \
1751           echo '  sys.exit(main.Main())'; \
1752         } > $@
1753         chmod u+x $@
1754
1755 $(HS_BUILT_TEST_HELPERS): Makefile
1756         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1757         set -e; \
1758         { echo '#!/bin/sh'; \
1759           echo '# This file is automatically generated, do not edit!'; \
1760           echo "# Edit Makefile.am instead."; \
1761           echo; \
1762           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1763         } > $@
1764         chmod u+x $@
1765
1766 stamp-directories: Makefile
1767         $(MAKE) $(AM_MAKEFLAGS) ganeti
1768         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1769         touch $@
1770
1771 # We need to create symlinks because "make distcheck" will not install Python
1772 # files when building.
1773 stamp-srclinks: Makefile | stamp-directories
1774         set -e; \
1775         for i in $(srclink_files); do \
1776           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1777             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1778           fi; \
1779         done
1780         touch $@
1781
1782 .PHONY: ganeti
1783 ganeti:
1784         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1785
1786 .PHONY: check-dirs
1787 check-dirs: $(GENERATED_FILES)
1788         @set -e; \
1789         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1790           error=; \
1791           while read dir; do \
1792             case "$$dir" in \
1793               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1794               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1795             esac; \
1796           done; \
1797           for dir in $(DIRS); do \
1798             if ! test -d "$$dir"; then \
1799               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1800               error=1; \
1801             fi \
1802           done; \
1803           test -z "$$error"; \
1804         }
1805
1806 .PHONY: check-local
1807 check-local: check-dirs $(GENERATED_FILES)
1808         $(CHECK_PYTHON_CODE) $(check_python_code)
1809         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1810         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1811         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1812         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1813         error= ; \
1814         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1815           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1816           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1817             echo "Incorrect version in README, expected $$expver" >&2; \
1818             error=1; \
1819           fi; \
1820           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1821               doc/security.rst; do \
1822             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1823               "Documents Ganeti version $$expver"; then \
1824               echo "Incorrect version in $$file, expected $$expver" >&2; \
1825               error=1; \
1826             fi; \
1827           done; \
1828           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1829             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1830             error=1; \
1831           fi; \
1832           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1833             ".. Last updated for Ganeti $$expver"; then \
1834             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1835             error=1; \
1836           fi; \
1837         fi; \
1838         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1839           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1840             echo "Longest line in $$file is longer than 80 characters" >&2; \
1841             error=1; \
1842           fi; \
1843         done; \
1844         test -z "$$error"
1845
1846 .PHONY: hs-test-%
1847 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1848         @rm -f htest.tix
1849         test/hs/htest -t $*
1850
1851 .PHONY: hs-tests
1852 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1853         @rm -f htest.tix
1854         ./test/hs/htest
1855
1856 .PHONY: hs-shell-%
1857 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
1858             $(HS_BUILT_TEST_HELPERS)
1859         @rm -f hpc-htools.tix hpc-mon-collector.tix
1860         HBINARY="./test/hs/hpc-htools" \
1861         SHELLTESTARGS=$(SHELLTESTARGS) \
1862         ./test/hs/offline-test.sh $*
1863
1864 .PHONY: hs-shell
1865 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1866         @rm -f hpc-htools.tix hpc-mon-collector.tix
1867         HBINARY="./test/hs/hpc-htools" \
1868         SHELLTESTARGS=$(SHELLTESTARGS) \
1869         ./test/hs/offline-test.sh
1870
1871 .PHONY: hs-check
1872 hs-check: hs-tests hs-shell
1873
1874 # E111: indentation is not a multiple of four
1875 # E121: continuation line indentation is not a multiple of four
1876 #       (since our indent level is not 4)
1877 # E125: continuation line does not distinguish itself from next logical line
1878 #       (since our indent level is not 4)
1879 # E127: continuation line over-indented for visual indent
1880 #       (since our indent level is not 4)
1881 # note: do NOT add E128 here; it's a valid style error in most cases!
1882 # I've seen real errors, but also some cases were we indent wrongly
1883 # due to line length; try to rework the cases where it is triggered,
1884 # instead of silencing it
1885 # E261: at least two spaces before inline comment
1886 # E501: line too long (80 characters)
1887 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1888
1889 # For excluding pep8 expects filenames only, not whole paths
1890 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1891
1892 LINT_TARGETS = pylint pylint-qa
1893 if HAS_PEP8
1894 LINT_TARGETS += pep8
1895 endif
1896 if HAS_HLINT
1897 LINT_TARGETS += hlint
1898 endif
1899
1900 .PHONY: lint
1901 lint: $(LINT_TARGETS)
1902
1903 .PHONY: pylint
1904 pylint: $(GENERATED_FILES)
1905         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1906         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1907
1908 .PHONY: pylint-qa
1909 pylint-qa: $(GENERATED_FILES)
1910         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1911         cd $(top_srcdir)/qa && \
1912           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1913           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1914
1915 .PHONY: pep8
1916 pep8: $(GENERATED_FILES)
1917         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1918         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1919           --repeat $(pep8_python_code)
1920
1921 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1922 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1923 .PHONY: hlint
1924 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1925         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1926         @rm -f doc/hs-lint.html
1927         if tty -s; then C="-c"; else C=""; fi; \
1928         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1929           --ignore "Use first" \
1930           --ignore "Use &&&" \
1931           --ignore "Use void" \
1932           --ignore "Reduce duplication" \
1933           --hint src/lint-hints \
1934           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1935         @if [ ! -f doc/hs-lint.html ]; then \
1936           echo "All good" > doc/hs-lint.html; \
1937         fi
1938
1939 # a dist hook rule for updating the vcs-version file; this is
1940 # hardcoded due to where it needs to build the file...
1941 dist-hook:
1942         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1943         rm -f $(top_distdir)/vcs-version
1944         cp -p $(srcdir)/vcs-version $(top_distdir)
1945
1946 # a distcheck hook rule for catching revision control directories
1947 distcheck-hook:
1948         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1949           echo "Found revision control files in final archive." 1>&2; \
1950           exit 1; \
1951         fi
1952         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1953           echo "Found Python byte code in final archive." 1>&2; \
1954           exit 1; \
1955         fi
1956         if find $(top_distdir) -name '*~' | grep .; then \
1957           echo "Found backup files in final archive." 1>&2; \
1958           exit 1; \
1959         fi
1960 # Empty files or directories should not be distributed. They can cause
1961 # unnecessary warnings for packagers. Directories used by automake during
1962 # distcheck must be excluded.
1963         if find $(top_distdir) -empty -and -not \( \
1964             -path $(top_distdir)/_build -or \
1965             -path $(top_distdir)/_inst \) | grep .; then \
1966           echo "Found empty files or directories in final archive." 1>&2; \
1967           exit 1; \
1968         fi
1969         if test -e $(top_distdir)/doc/man-html; then \
1970           echo "Found documentation including man pages in final archive" >&2; \
1971           exit 1; \
1972         fi
1973
1974 # Backwards compatible distcheck-release target
1975 distcheck-release: distcheck
1976
1977 distrebuildcheck: dist
1978         set -e; \
1979         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1980         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1981         cd $$builddir; \
1982         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1983         cd $(distdir); \
1984         ./configure; \
1985         $(MAKE) maintainer-clean; \
1986         cp $(abs_srcdir)/vcs-version .; \
1987         ./configure; \
1988         $(MAKE) $(AM_MAKEFLAGS)
1989
1990 dist-release: dist
1991         set -e; \
1992         for i in $(DIST_ARCHIVES); do \
1993           echo -n "Checking $$i ... "; \
1994           autotools/check-tar < $$i; \
1995           echo OK; \
1996         done
1997
1998 install-exec-local:
1999         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2000           "$(DESTDIR)${localstatedir}/log/ganeti" \
2001           "$(DESTDIR)${localstatedir}/run/ganeti"
2002
2003 .PHONY: apidoc
2004 if WANT_HSAPIDOC
2005 apidoc: py-apidoc hs-apidoc
2006 else
2007 apidoc: py-apidoc
2008 endif
2009
2010 .PHONY: py-apidoc
2011 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2012         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2013         $(RUN_IN_TEMPDIR) epydoc -v \
2014           --conf $(CURDIR)/epydoc.conf \
2015           --output $(CURDIR)/$(APIDOC_PY_DIR)
2016
2017 .PHONY: hs-apidoc
2018 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2019
2020 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2021         @test -n "$(HSCOLOUR)" || \
2022             { echo 'HsColour' not found during configure; exit 1; }
2023         @test -n "$(HADDOCK)" || \
2024             { echo 'haddock' not found during configure; exit 1; }
2025         rm -rf $(APIDOC_HS_DIR)/*
2026         for i in $(ALL_APIDOC_HS_DIRS); do \
2027           @mkdir_p@ $$i; \
2028           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2029         done
2030         set -e ; \
2031         export LC_ALL=en_US.UTF-8; \
2032         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2033         if [ "$(HS_PARALLEL3)" ]; \
2034         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2035         fi; \
2036         if [ "$(HS_REGEX_PCRE)" ]; \
2037         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2038         fi; \
2039         for file in $(HS_LIBTESTBUILT_SRCS); do \
2040           f_nosrc=$${file##src/}; \
2041           f_notst=$${f_nosrc##test/hs/}; \
2042           f_html=$${f_notst%%.hs}.html; \
2043           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2044         done ; \
2045         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2046           -t ganeti -p src/haddock-prologue \
2047           --source-module="%{MODULE/.//}.html" \
2048           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2049           $$OPTGHC \
2050           $(HS_LIBTESTBUILT_SRCS)
2051
2052 .PHONY: TAGS
2053 TAGS: $(GENERATED_FILES)
2054         rm -f TAGS
2055         $(GHC) -e ":etags" -v0 \
2056           $(filter-out -O -Werror,$(HFLAGS)) \
2057           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2058           $(HS_LIBTEST_SRCS)
2059         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2060           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2061           -path './qa/*.py' | \
2062           etags -l python -a -
2063
2064 .PHONY: coverage
2065
2066 COVERAGE_TESTS=
2067 if WANT_HTOOLS
2068 COVERAGE_TESTS += hs-coverage
2069 endif
2070 if PY_UNIT
2071 COVERAGE_TESTS += py-coverage
2072 endif
2073
2074 coverage: $(COVERAGE_TESTS)
2075
2076 .PHONY: py-coverage
2077 py-coverage: $(GENERATED_FILES) $(python_tests)
2078         @test -n "$(PYCOVERAGE)" || \
2079             { echo 'python-coverage' not found during configure; exit 1; }
2080         set -e; \
2081         COVERAGE=$(PYCOVERAGE) \
2082         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2083         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2084         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2085         $(PLAIN_TESTS_ENVIRONMENT) \
2086         $(abs_top_srcdir)/autotools/gen-py-coverage \
2087         $(python_tests)
2088
2089 .PHONY: hs-coverage
2090 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2091         rm -f *.tix
2092         $(MAKE) $(AM_MAKEFLAGS) hs-check
2093         @mkdir_p@ $(COVERAGE_HS_DIR)
2094         hpc sum --union $(HPCEXCL) \
2095           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2096         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2097         hpc report coverage-hs.tix
2098         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2099
2100 # Special "kind-of-QA" target for htools, needs special setup (all
2101 # tools compiled with -fhpc)
2102 .PHONY: live-test
2103 live-test: all
2104         set -e ; \
2105         cd src; \
2106         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2107         rm -f *.tix *.mix; \
2108         ./live-test.sh; \
2109         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2110           --output=live-test.tix ; \
2111         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2112         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2113           --srcdir=.. $(HPCEXCL) ; \
2114         hpc report --srcdir=.. live-test $(HPCEXCL)
2115
2116 commit-check: autotools-check distcheck lint apidoc
2117
2118 autotools-check:
2119         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2120   $(abs_top_srcdir)/test/autotools/*-*.test \
2121   -- --hide-successes
2122
2123 .PHONY: gitignore-check
2124 gitignore-check:
2125         @if [ -n "`git status --short`" ]; then \
2126           echo "Git status is not clean!" 1>&2 ; \
2127           git status --short; \
2128           exit 1; \
2129         fi
2130
2131 # target to rebuild all man pages (both groff and html output)
2132 .PHONY: man
2133 man: $(man_MANS) $(manhtml)
2134
2135 # Target that builds all binaries (including those that are not
2136 # rebuilt except when running the tests)
2137 .PHONY: really-all
2138 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2139
2140 # we don't need the ancient implicit rules:
2141 %: %,v
2142 %: RCS/%,v
2143 %: RCS/%
2144 %: s.%
2145 %: SCCS/s.%
2146
2147 -include ./Makefile.local
2148
2149 # vim: set noet :